-- This file is part of the it-crafts software and is subject to copyright protection.
-- (C) 2022..2026, All rights reserved by Steffen Anders, Elsteraue - Germany
-- Visit also https://www.it-crafts.de.
--

IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_Langtextzeilen')
BEGIN
CREATE TABLE [dbo].[ut_Langtextzeilen]
(
  [RecId]  integer NOT NULL
 ,[Art] char(2) DEFAULT ''
 ,[Lkz] char(2) DEFAULT ''
 ,[Nr] char(18) DEFAULT ''
 ,[LfdNr] char(3) DEFAULT ''
 ,[Abschluss] tinyint DEFAULT 0
 ,[SoftBreak] tinyint DEFAULT 0
 ,[LineFeeds] integer DEFAULT 0
 ,[CntChar] integer DEFAULT 0
 ,[Daten] varchar(55) DEFAULT ''
  CONSTRAINT [Pk_Langtextzeilen]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO

-- drop obsolete triggers and the triggered table with keyvalues
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Langtextzeilen_KeyDel')
  DROP TRIGGER [dbo].[tr_Langtextzeilen_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Langtextzeilen_KeyUpd')
  DROP TRIGGER [dbo].[tr_Langtextzeilen_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_Langtextzeilen_Keys')
  DROP TABLE [dbo].[ut_Langtextzeilen_Keys]
GO

-- add new fields
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Art')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [Art] char(2) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Lkz')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [Lkz] char(2) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Nr')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [Nr] char(18) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LfdNr')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [LfdNr] char(3) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Abschluss')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [Abschluss] tinyint NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'SoftBreak')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [SoftBreak] tinyint NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LineFeeds')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [LineFeeds] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'CntChar')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [CntChar] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Daten')
BEGIN
  ALTER TABLE [dbo].[ut_Langtextzeilen] ADD [Daten] varchar(55) NOT NULL DEFAULT ''
END
GO

-- check lengths of text fields
IF (2 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Art'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Art'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Art] char(2)
END
GO
IF (2 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Art'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Art'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Art] varchar(2)
END
GO
IF (2 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Lkz'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Lkz'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Lkz] char(2)
END
GO
IF (2 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Lkz'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Lkz'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Lkz] varchar(2)
END
GO
IF (18 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Nr'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Nr'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Nr] char(18)
END
GO
IF (18 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Nr'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Nr'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Nr] varchar(18)
END
GO
IF (3 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LfdNr'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LfdNr'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [LfdNr] char(3)
END
GO
IF (3 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LfdNr'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'LfdNr'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [LfdNr] varchar(3)
END
GO
IF (55 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Daten'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Daten'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Daten] char(55)
END
GO
IF (55 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Daten'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Langtextzeilen' and sc.[name] = 'Daten'))
BEGIN
   ALTER TABLE [dbo].[ut_Langtextzeilen] ALTER COLUMN [Daten] varchar(55)
END
GO

-- create dedicated view
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'Langtextzeilen')
  DROP VIEW [dbo].[Langtextzeilen]
GO
CREATE VIEW [dbo].[Langtextzeilen] AS
  SELECT [RecId]
 ,[Art]
 ,[Lkz]
 ,[Nr]
 ,[LfdNr]
 ,[Abschluss]
 ,[SoftBreak]
 ,[LineFeeds]
 ,[CntChar]
 ,[Daten]
  FROM [dbo].[ut_Langtextzeilen]
GO


-- create function to get the next RecId
IF OBJECT_ID (N'itcfunc_NextRecId_Langtextzeilen', N'FN') IS NOT NULL
  DROP FUNCTION dbo.itcfunc_NextRecId_Langtextzeilen
GO
CREATE FUNCTION dbo.itcfunc_NextRecId_Langtextzeilen() RETURNS integer
AS
BEGIN
  RETURN isnull((SELECT MAX(RecId) FROM [dbo].[ut_Langtextzeilen] WITH (READUNCOMMITTED)),0) + 1
END
GO

-- select with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Sel_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Sel_Langtextzeilen]  @mRI integer
AS
  SELECT
    [Art]
   ,[Lkz]
   ,[Nr]
   ,[LfdNr]
   ,[Abschluss]
   ,[SoftBreak]
   ,[LineFeeds]
   ,[CntChar]
   ,[Daten]
  FROM [dbo].[ut_Langtextzeilen] WHERE RecId = @mRI
GO

-- select with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel2_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Sel2_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Sel2_Langtextzeilen]  @Param_RecId varchar(20)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  SELECT * FROM [dbo].[Langtextzeilen] WHERE RecId = @mRI
GO

-- insert with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Append_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Append_Langtextzeilen]
   @Param_Art char(2)
  ,@Param_Lkz char(2)
  ,@Param_Nr char(18)
  ,@Param_LfdNr char(3)
  ,@Param_Abschluss tinyint
  ,@Param_SoftBreak tinyint
  ,@Param_LineFeeds integer
  ,@Param_CntChar integer
  ,@Param_Daten varchar(55)
AS
  DECLARE @NeueId integer
  DECLARE @m_CountDown integer = 10
  WHILE @m_CountDown > 0 BEGIN
    BEGIN TRANSACTION
    BEGIN TRY
      SET @NeueId = dbo.itcfunc_NextRecId_Langtextzeilen()
      INSERT INTO [dbo].[ut_Langtextzeilen] (RecId
        ,[Art]
        ,[Lkz]
        ,[Nr]
        ,[LfdNr]
        ,[Abschluss]
        ,[SoftBreak]
        ,[LineFeeds]
        ,[CntChar]
        ,[Daten]
          ) VALUES (@NeueId
        ,UPPER(RTRIM(@Param_Art))
        ,UPPER(RTRIM(@Param_Lkz))
        ,UPPER(RTRIM(@Param_Nr))
        ,UPPER(RTRIM(@Param_LfdNr))
        ,@Param_Abschluss
        ,@Param_SoftBreak
        ,@Param_LineFeeds
        ,@Param_CntChar
        ,RTRIM(@Param_Daten)
          )
      COMMIT TRANSACTION
    END TRY
    BEGIN CATCH
      ROLLBACK TRANSACTION
      SET @NeueId = 0
    END CATCH

    IF @NeueId <> 0
      SET @m_CountDown = 0
    ELSE
      SET @m_CountDown = @m_CountDown - 1

    IF @m_CountDown > 0
      WAITFOR DELAY '00:00:00.050'
  END -- WHILE
  SELECT @NeueId AS RecId
GO

-- insert with obsolete clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Add_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Add_Langtextzeilen]
AS
  DECLARE @NeueId integer = dbo.itcfunc_NextRecId_Langtextzeilen()
  INSERT INTO [dbo].[ut_Langtextzeilen] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
    SELECT @NeueId AS RecId
  ELSE
    SELECT 0 AS RecId
GO

-- update with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Upd_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Upd_Langtextzeilen] @mRI integer
  ,@Param_Art char(2)
  ,@Param_Lkz char(2)
  ,@Param_Nr char(18)
  ,@Param_LfdNr char(3)
  ,@Param_Abschluss tinyint
  ,@Param_SoftBreak tinyint
  ,@Param_LineFeeds integer
  ,@Param_CntChar integer
  ,@Param_Daten varchar(55)
AS
  UPDATE [dbo].[ut_Langtextzeilen] SET
    [Art] = UPPER(RTRIM(@Param_Art))
   ,[Lkz] = UPPER(RTRIM(@Param_Lkz))
   ,[Nr] = UPPER(RTRIM(@Param_Nr))
   ,[LfdNr] = UPPER(RTRIM(@Param_LfdNr))
   ,[Abschluss] = @Param_Abschluss
   ,[SoftBreak] = @Param_SoftBreak
   ,[LineFeeds] = @Param_LineFeeds
   ,[CntChar] = @Param_CntChar
   ,[Daten] = RTRIM(@Param_Daten)
  WHERE RecId = @mRI
GO

-- update with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd2_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Upd2_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Upd2_Langtextzeilen] @Param_RecId varchar(20)
  ,@Param_Art varchar(2)
  ,@Param_Lkz varchar(2)
  ,@Param_Nr varchar(18)
  ,@Param_LfdNr varchar(3)
  ,@Param_Abschluss varchar(1)
  ,@Param_SoftBreak varchar(1)
  ,@Param_LineFeeds varchar(2)
  ,@Param_CntChar varchar(2)
  ,@Param_Daten varchar(55)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  UPDATE [dbo].[ut_Langtextzeilen] SET
    [Art] = UPPER(RTRIM(@Param_Art))
   ,[Lkz] = UPPER(RTRIM(@Param_Lkz))
   ,[Nr] = UPPER(RTRIM(@Param_Nr))
   ,[LfdNr] = UPPER(RTRIM(@Param_LfdNr))
   ,[Abschluss] = dbo.itcfunc_integer(@Param_Abschluss)
   ,[SoftBreak] = dbo.itcfunc_integer(@Param_SoftBreak)
   ,[LineFeeds] = dbo.itcfunc_integer(@Param_LineFeeds)
   ,[CntChar] = dbo.itcfunc_integer(@Param_CntChar)
   ,[Daten] = RTRIM(@Param_Daten)
  WHERE RecId = @mRI

  EXECUTE [dbo].[up_Sel2_Langtextzeilen] @mRI
GO

-- delete
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Del_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Del_Langtextzeilen] @mRI integer
AS
  DELETE FROM [dbo].[ut_Langtextzeilen] WHERE RecId = @mRI
GO

-- text index
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_TrSel_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_TrSel_Langtextzeilen]
AS
  SELECT RecId,
    LTRIM(RTRIM([Art]))
   +LTRIM(RTRIM([Lkz]))
   +LTRIM(RTRIM([Nr]))
   +LTRIM(RTRIM([LfdNr]))
   +LTRIM(RTRIM([Daten]))
  AS Data FROM [dbo].[ut_Langtextzeilen] WHERE RecId > 0 ORDER BY RecId
GO

-- reindex
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_Langtextzeilen')
  DROP PROCEDURE [dbo].[up_Reorg_Langtextzeilen]
GO
CREATE PROCEDURE [dbo].[up_Reorg_Langtextzeilen] @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_Langtextzeilen] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_Langtextzeilen] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_Langtextzeilen] )
  END
GO

-- logical key  ORDER BY Art,Lkz,Nr,LfdNr,RecId
IF 0 < (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_Langtextzeilen' and so.[id] = si.[id] and si.[name] = 'Ik_Primary')
  DROP INDEX [Ik_Primary] ON [dbo].[ut_Langtextzeilen]
GO
IF 0 = (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_Langtextzeilen' and so.[id] = si.[id] and si.[name] = 'Ik_Primary')
  CREATE INDEX [Ik_Primary] ON [dbo].[ut_Langtextzeilen] (Art,Lkz,Nr,LfdNr,RecId)
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_First_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_First_Langtextzeilen_Primary] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) ORDER BY Art,Lkz,Nr,LfdNr,RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_First_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_First_Langtextzeilen_Primary] AS EXECUTE [dbo].[up_First_Langtextzeilen_Primary]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_Last_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_Last_Langtextzeilen_Primary] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Last_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Last_Langtextzeilen_Primary] AS EXECUTE [dbo].[up_Last_Langtextzeilen_Primary]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_Next_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_Next_Langtextzeilen_Primary] @oldRecId integer AS
  DECLARE @oldArt char(2)
  DECLARE @oldLkz char(2)
  DECLARE @oldNr char(18)
  DECLARE @oldLfdNr char(3)
  SELECT @oldArt = Art, @oldLkz = Lkz, @oldNr = Nr, @oldLfdNr = LfdNr FROM [dbo].[ut_Langtextzeilen] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz = @oldLkz) AND (Nr = @oldNr) AND (LfdNr > @oldLfdNr)
    ORDER BY Art,Lkz,Nr,LfdNr,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz = @oldLkz) AND (Nr > @oldNr)
    ORDER BY Art,Lkz,Nr,LfdNr,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz > @oldLkz)
    ORDER BY Art,Lkz,Nr,LfdNr,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art > @oldArt)
    ORDER BY Art,Lkz,Nr,LfdNr,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Next_Langtextzeilen_Primary] @oldRecId integer AS EXECUTE [dbo].[up_Next_Langtextzeilen_Primary] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_Prior_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_Prior_Langtextzeilen_Primary] @oldRecId integer AS
  DECLARE @oldArt char(2)
  DECLARE @oldLkz char(2)
  DECLARE @oldNr char(18)
  DECLARE @oldLfdNr char(3)
  SELECT @oldArt = Art, @oldLkz = Lkz, @oldNr = Nr, @oldLfdNr = LfdNr FROM [dbo].[ut_Langtextzeilen] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz = @oldLkz) AND (Nr = @oldNr) AND (LfdNr < @oldLfdNr)
    ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz = @oldLkz) AND (Nr < @oldNr)
    ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art = @oldArt) AND (Lkz < @oldLkz)
    ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary)
    WHERE (Art < @oldArt)
    ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Prior_Langtextzeilen_Primary] @oldRecId integer AS EXECUTE [dbo].[up_Prior_Langtextzeilen_Primary] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_Next50_Langtextzeilen_Primary]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next50_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[qp_Next50_Langtextzeilen_Primary]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_Prior50_Langtextzeilen_Primary]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior50_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[qp_Prior50_Langtextzeilen_Primary]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_FindF_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_FindF_Langtextzeilen_Primary] @xKey char(250), @xLen integer AS
  DECLARE @mArt char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,2)
  DECLARE @mLkz char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,3,2)
  DECLARE @mNr char(18) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,5,18)
  DECLARE @mLfdNr char(3) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,23,3)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 25 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr AND 
      LfdNr = @mLfdNr
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen = 22 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen = 4 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen = 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art >= @mArt AND SUBSTRING(Art,1,LEN(@mArt)) = @mArt
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen < 4 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz >= @mLkz AND SUBSTRING(Lkz,1,LEN(@mLkz)) = @mLkz
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen < 22 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr >= @mNr AND SUBSTRING(Nr,1,LEN(@mNr)) = @mNr
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  IF @xLen < 25 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr AND 
      LfdNr >= @mLfdNr AND SUBSTRING(LfdNr,1,LEN(@mLfdNr)) = @mLfdNr
      ORDER BY Art,Lkz,Nr,LfdNr,RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindF_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindF_Langtextzeilen_Primary] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindF_Langtextzeilen_Primary] @xKey, @xLen')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_Langtextzeilen_Primary')
  DROP PROCEDURE [dbo].[up_FindL_Langtextzeilen_Primary]
GO
CREATE PROCEDURE [dbo].[up_FindL_Langtextzeilen_Primary] @xKey char(250), @xLen integer AS
  DECLARE @mArt char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,2)
  DECLARE @mLkz char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,3,2)
  DECLARE @mNr char(18) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,5,18)
  DECLARE @mLfdNr char(3) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,23,3)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 25 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr AND 
      LfdNr = @mLfdNr
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen = 22 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen = 4 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen = 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      SUBSTRING(Art,1,LEN(@mArt)) = @mArt
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen < 4 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      SUBSTRING(Lkz,1,LEN(@mLkz)) = @mLkz
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen < 22 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      SUBSTRING(Nr,1,LEN(@mNr)) = @mNr
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  IF @xLen < 25 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Langtextzeilen] WITH(INDEX = Ik_Primary) WHERE 
      Art = @mArt AND 
      Lkz = @mLkz AND 
      Nr = @mNr AND 
      SUBSTRING(LfdNr,1,LEN(@mLfdNr)) = @mLfdNr
      ORDER BY Art desc,Lkz desc,Nr desc,LfdNr desc,RecId desc
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindL_Langtextzeilen_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindL_Langtextzeilen_Primary] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindL_Langtextzeilen_Primary] @xKey, @xLen')
GO


